Last Comment Bug 240914 - "text-align: justify" ruins Unicode combining characters (e.g. Devanagari, Tamil, Bengali,Malayalam,Kannada)
: "text-align: justify" ruins Unicode combining characters (e.g. Devanagari, Ta...
Status: RESOLVED FIXED
: intl
Product: Core
Classification: Components
Component: Layout: Text (show other bugs)
: Trunk
: x86 Windows XP
: -- normal with 16 votes (vote)
: ---
Assigned To: Stuart Parmenter
:
Mentors:
http://www.shujan.org/test.htm
: 202351 270012 278291 348792 393051 420135 428641 (view as bug list)
Depends on: uniscribe 367177
Blocks: 361783
  Show dependency treegraph
 
Reported: 2004-04-18 15:58 PDT by John Coonrod
Modified: 2009-02-20 07:35 PST (History)
19 users (show)
pavlov: blocking1.9+
jwalden+bmo: in‑testsuite?
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
Indic bug on Mozilla Firefox (2.56 KB, text/html)
2005-08-15 11:35 PDT, H P Nadig
no flags Details
The Attachment is an HTML file with four types of text-align property. Left, right and center work fine. But justify ruins the kannada characters. Same works in IE. (710 bytes, text/html)
2005-11-24 09:25 PST, Sunil Jayaprakash
no flags Details

Description John Coonrod 2004-04-18 15:58:53 PDT
User-Agent:       Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7b) Gecko/20040316
Build Identifier: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7b) Gecko/20040316

Bangla fonts require unicode glyphs to be combined. Text justify prevents
unicode characters from combining - perhaps because of insertion of spacers?

Reproducible: Always
Steps to Reproduce:
1. Look at the page in IE
2. Look at the page in Mozilla
3.

Actual Results:  
dotted circles appear between characters that should have combined.

Expected Results:  
the characters should have combined.
Comment 1 Jungshik Shin 2004-04-19 00:22:09 PDT
This could well be resolved as a dupe of bug 218887, but I'm just making it
depend on bug 218887, instead for a better (?) tracking. 

What's happening is that Mozilla-Win uses the standard Windows text
drawing/measuring APIs that work well for 'unjustified' text (complex or not),
but that breaks down when it comes to justified text. The best way to fix is to
use Uniscribe like MS IE does, which is what bug 218887 is about.
Comment 2 Richard Ishida 2004-07-23 04:47:02 PDT
I have found the same problem with Devanagari text, but interestingly not with
combining characters in Arabic text.
Comment 3 Simon Montagu :smontagu 2004-07-23 10:09:00 PDT
That is because Mozilla has its own character shaping routines for Arabic text
which it uses when necessary, but not for Indic or other scripts.
Comment 4 Jungshik Shin 2005-04-03 13:20:11 PDT
*** Bug 278291 has been marked as a duplicate of this bug. ***
Comment 5 Jungshik Shin 2005-04-09 20:50:29 PDT
*** Bug 270012 has been marked as a duplicate of this bug. ***
Comment 6 Manmathan Kumarathurai 2005-04-18 16:55:16 PDT
The problem also exist on Linux with Pango, etc. Firefox 1.0.2 on Fedora Core 3.
Comment 7 Cibu C J 2005-04-28 07:55:35 PDT
The test URL (http://www.shujan.org/test.htm) does not work. Please visit 
http://samakaalikam.blogspot.com/ to see the described effect.
Comment 8 Jesse Ruderman 2005-07-02 17:48:23 PDT
*** Bug 270012 has been marked as a duplicate of this bug. ***
Comment 9 H P Nadig 2005-07-31 01:52:01 PDT
This problem exists with the usage of following CSS properties, as well:
1) word-spacing 
2) letter-spacing

Also, the problem is not only on Bangla, Devanagari and Tamil, but on Kannada,
and almost all indic (http://en.wikipedia.org/wiki/Indic) scripts.

Comment 10 Omi Azad 2005-08-12 03:53:41 PDT
I found this bug today. It's really disturbing to have a bug like this. Actually
it's not a bug indeed. I know about the site shujan.org, that site used
Microsoft WEFT technology for embedding font with the site. So IE users can see
the site from any Windows platform. But Microsoft didn't make any plug-in for
Firefox/Mozilla, so Mozilla/Firefox users cannot see the site.

On the other hand the site used Unicode Bengali font, so if anyone has Unicode
Bengali support on their OS, then they can see the site without any problem.
Unicode Bengali means: you should have at least one Unicode based Bengali font
installed in your system, you should have Unicode rendaring support from your OS.

Some Linux distributions comes with Mozilla products, but they cannot render
Indic language, such as Bengali. Power users can compile their own version with
Indic rendering support. We call this Pango enabled. But there is no problem
with Windows. Well, I must mention that you cannot see a Unicode site with
Windows 9x. Because 9x versions of Windows doesn't have Unicode support. So
Mozill products are helpless for 9x users. But if you face problem in Windows
2000/XP/2003, then you must follow some steps like:
http://www.ekushey.org/projects/shadhinota/technical/

I request Mozilla team to close this bug as soon as possible. The reported bug
is actually not a bug. Users have to change some configurations on their sustem
for make Unicode/Indic work in their Windows box.
Comment 11 Simos Xenitellis 2005-08-15 09:44:36 PDT
Could we please clear up this bug report a bit?

A. Please mention in one go all the CSS attributes that break the display for
combining characters.
B. Please provide as attachments, minimal examples that show each problem case.
That is, HTML code with sample text and then the same text with the CSS applied.
Also, a screenshot would be excellent for those developers who are not
well-versed in Indic languages.

Doing some work on the quality of the bug report will help to fix the problem
sooner.

(I am not a Mozilla developer)
Comment 12 H P Nadig 2005-08-15 11:35:06 PDT
Created attachment 192745 [details]
Indic bug on Mozilla Firefox

hmm... guess you didn't check the other bugs that've been marked duplicate and
dependent of this one.

Tamil & Kannada test cases are here:
https://bugzilla.mozilla.org/show_bug.cgi?id=278291

Anyways, I'm attaching another test case, if that proves helpful to you.

You need to get an Open Type font for Kannada from:
http://salrc.uchicago.edu/resources/fonts/main.html
to view the attachment.

For those who intend to put me a question what 'Indic' is, wikipedia has the
answer for you:
http://en.wikipedia.org/wiki/Indic
Comment 13 Omi Azad 2005-08-15 22:04:31 PDT
Are you guys sure that it's not a problem of Font? Because with a perfect
Bengali font, FireFox doesn't have any problem.
Comment 14 Jungshik Shin 2005-08-16 01:33:53 PDT
(In reply to comment #13)
> Are you guys sure that it's not a problem of Font? Because with a perfect
> Bengali font, FireFox doesn't have any problem.

We developers do know what this bug is about. There IS a bug on our side. 
Comment 15 Sunil Jayaprakash 2005-11-24 09:25:58 PST
Created attachment 204128 [details]
The Attachment is an HTML file with four types of text-align property. Left, right and center work fine. But justify ruins the kannada characters. Same works in IE.

Along with Devanagari, Tamil and Malayalam, Even Kannada characters are badly rendered wih text-align:justify property.
Comment 16 Sunil Jayaprakash 2005-11-24 09:37:08 PST
Comment on attachment 204128 [details]
The Attachment is an HTML file with four types of text-align property. Left, right and center work fine. But justify ruins the kannada characters. Same works in IE.

I have tested with Arial Unicode  MS, Tunga, Kedage(from Indian Institute Of Science) fonts and I have found that problem persists. Hence its not a problem of font
Comment 17 Stephen Blackheath 2005-11-28 11:58:59 PST
I am working on this problem, which also affects Hebrew and Arabic.  See my web page at

http://blacksapphire.com/firefox-rtl/

You can test patched versions of Firefox here.
Comment 18 R. Rajesh Jeba Anbiah 2006-06-03 10:56:04 PDT
I would like to know what is been happening here. Most of the duplicate bugs have been marked "Resolved" though the bug remains for years and FF losing indic users.

Comment #17 shows that someone has already patched FF, but not yet been taken seriously. Could any developers take it seriously or at least apply the patch to official version? Thanks.
Comment 19 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2006-06-03 13:59:25 PDT
Nominating for blocking1.9a2? although I really mean 1.9.  I expect this will be fixed for Gecko 1.9 (i.e., Firefox 3.0, the next version of Firefox that's taking significant core changes).
Comment 20 Omi Azad 2006-06-04 05:04:35 PDT
FireFox 3.0 !!!!
2.0 is yet to come man...
Comment 21 timeless 2006-07-02 06:43:51 PDT
2.0 is not a core gecko feature release, it's a ui refresh, 3.0 is the soonest this is likely to be fixed.
Comment 22 timeless 2006-07-02 06:44:04 PDT
*** Bug 202351 has been marked as a duplicate of this bug. ***
Comment 23 Jungshik Shin 2006-08-09 01:28:49 PDT
Give it to Pavlov. This may already have been fixed in minefield. 
Comment 24 Simon Montagu :smontagu 2006-08-16 01:13:49 PDT
*** Bug 348792 has been marked as a duplicate of this bug. ***
Comment 25 Pari 2006-08-16 14:31:27 PDT
(In reply to comment #19)
> Nominating for blocking1.9a2? although I really mean 1.9.  I expect this will
> be fixed for Gecko 1.9 (i.e., Firefox 3.0, the next version of Firefox that's
> taking significant core changes).
> 

I have converted many IE users to Firefox, but they just went back to IE. Why? They can't read Indic blogs in firefox. Almost all templates in blogger have this CSS setting. If your attitude to fixing this is "sometime in the future" you are not winning any market share in Indic world. IE7 is about to hit the market soon, so they will be content and happy with it.
(In reply to comment #19)
> Nominating for blocking1.9a2? although I really mean 1.9.  I expect this will
> be fixed for Gecko 1.9 (i.e., Firefox 3.0, the next version of Firefox that's
> taking significant core changes).
> 
Comment 26 Stuart Parmenter 2007-06-19 16:48:16 PDT
this is fixed with the new textframe
Comment 27 Stuart Parmenter 2007-06-20 14:57:52 PDT
fixed by roc's landing of new textframe
Comment 28 Osho GG 2007-08-09 09:43:43 PDT
This one is marked as fixed. Could you please tell us which version of firefox has the fix? I see that http://www.bbchindi.com/ still displays incorrectly with firefox 2.0.0.6 on Linux (it works fine on windows with the same version).

thanks,
Osho
Comment 29 Martijn Wargers [:mwargers] (gone per 2016-05-31 :-( ) 2007-08-09 09:50:06 PDT
You need to test it with trunk builds to see whether it is fixed for you:
http://ftp.mozilla.org/pub/mozilla.org/firefox/nightly/latest-trunk/
Comment 30 Kevin Brosnan 2007-08-21 11:12:42 PDT
*** Bug 393051 has been marked as a duplicate of this bug. ***
Comment 31 Alok Jain 2008-01-28 02:40:21 PST
I started a discussion post here http://forums.mozillazine.org/viewtopic.php?t=623138

If anybody needs help on testing of Hindi fonts in firefox to resolve this issue, i will be glad to offer my help.

Also Please let me know if anybody has found a solution for this problem.

Thanks,
Alok
Comment 32 Simon Montagu :smontagu 2008-02-28 20:40:32 PST
*** Bug 420135 has been marked as a duplicate of this bug. ***
Comment 33 Simon Montagu :smontagu 2008-04-13 04:55:00 PDT
*** Bug 428641 has been marked as a duplicate of this bug. ***

Note You need to log in before you can comment on or make changes to this bug.